program similarrows;

const infile  = 'simrows.in';
      outfile = 'simrows.out';
      maxn    = 500;

type TCompare = function (id1, id2 : longint) : boolean;

var a, b : array[1..maxn, 1..maxn] of longint;
    n, best : longint;

procedure init;
var i, j : longint;
 begin
  assign(input, infile);
  reset(input);
  assign(output, outfile);
  rewrite(output);
  read(n);
  for i := 1 to n do
   for j := 1 to n do read(a[i, j]);
 end;

var currow : longint;
    curcmp : TCompare;
    t, tmp : array[1..maxn] of longint;

function integer_compare(id1, id2 : longint) : boolean;
 begin
  result := a[currow, id1] <= a[currow, id2];
 end;

function less(id1, id2 : longint) : byte;
var i : longint;
 begin
  i := 1;
  while i < n do begin
    if b[id1, i] <> b[id2, i] then break;
    i := i + 1;
   end;
  if b[id1, i] < b[id2, i] then result := 1 else
  if b[id1, i] > b[id2, i] then result := 2 else result := 0; 
 end;

function array_compare(id1, id2 : longint) : boolean;
var i : longint;
 begin
  i := 1;
  while i < n do begin
    if b[id1, i] <> b[id2, i] then break;
    i := i + 1;
   end;
  result := b[id1, i] <= b[id2, i];
 end;

procedure merge(l, m, r : longint);
var lind, rind, cind : longint;
 begin
  lind := l;
  rind := m + 1;
  for cind := l to r do
   if (lind <= m) and ((rind > r) or curcmp(t[lind], t[rind])) then begin
     tmp[cind] := t[lind];
     lind := lind + 1;
    end else begin
     tmp[cind] := t[rind];
     rind := rind + 1;
    end;
  for cind := l to r do t[cind] := tmp[cind];  
 end; 

procedure mergesort(l, r : longint);
var m : longint;
 begin
  if l + 1 >= r then begin
    if l + 1 = r then merge(l, l, r);
    exit;
   end;
  m := (l + r) div 2;
  mergesort(l, m);
  mergesort(m + 1, r);
  merge(l, m, r); 
 end; 

procedure solve;
var i, j : longint;
 begin
  curcmp := integer_compare;
  for i := 1 to n do begin
    for j := 1 to n do t[j] := j;
    currow := i;
    mergesort(1, n);
    for j := 1 to n do b[i, j] := a[i, t[j]];
   end;

  curcmp := array_compare;
  for j := 1 to n do t[j] := j;
  mergesort(1, n);

  best := 0;
  for j := 1 to n - 1 do
   if less(t[j], t[j + 1]) = 0 then
    if (best = 0) or (t[j] < best) then best := t[j];
 end;

procedure save;
 begin
  writeln(best);
  close(output);
 end;

begin
 init;
 solve;
 save;
end.